/* pravoug.c - Nalazenje odredjenog integrala metodom pravougaonika.      */

#include <math.h>
#define MAX 20

void pravoug (double (*f)(double), double xa, double xb, double eps,
              double *y, int *uspeh) {
  long k = 0, n = 1, i; double dx  = xb - xa, y0 = 1e38;
  *y = (*f) (xa) * dx;
  while (k<=MAX && fabs(*y-y0)>eps*fabs(*y)) {
    y0 = *y; n += n; dx *= 0.5;
    for (*y=i=0; i<n; i++) *y += (*f) (xa+i*dx);
    *y *= dx; k++;
  }
  *uspeh = k <= MAX;
}
